/**
 * Copyright 2011, FMR LLC.
 * All Rights Reserved.
 * Fidelity Confidential Information
 *
 * @author Ice Wang (a492978)
 * @author Eoin O'Connor (a413117)
 * @author Nylon Gao (a488606)
 */

/**
 *
 * @param {Object} argToolBarType				this is tool bar type --.eg:(submit_payments ,preview_pending-payment,preview_scheduling_payment).
 * @param {Object} argIsToolBarTypeDisable		tool bar enable or disable eg:(enable,disable)
 * @param {Object} argTotalPay					It's will display total payments in the toolbar.
 * @param {Object} argNewTitle					If you go to the other page ,It would display new title --eg:(Preview Payment, Preview Changes,Important Information)
 * @param {Object} argIsToolBarVisable			the toolbar show or hide eg(YES or NO)
 * @param {Object} argIdType						this is every page id. for example, the billpay.html include those id.(like '#confirmation_info'). when you go back to previous page,then you need to set this parameter,except previous page had not any dynamic data .
 */
function goBackInfomations(argToolBarType, argIsToolBarTypeDisable, argTotalPay, argNewTitle, argIsToolBarVisable, argIdType)
{
    var everyInfos = [];
    everyInfos.push(argToolBarType);
    everyInfos.push(argIsToolBarTypeDisable);
    everyInfos.push(argTotalPay);
    everyInfos.push(argNewTitle);
    everyInfos.push(argIsToolBarVisable);
    everyInfos.push(argIdType);
    page_transition_stack.push(everyInfos);
}

/**
 *
 * @param {Object} argToolBarType			this is tool bar type --.eg:(submit_payments ,preview_pending-payment,preview_scheduling_payment).
 * @param {Object} argDisableToolBar		tool bar enable or disable
 * @param {Object} argTotalPaymentAmt		It's will display total payments in the toolbar
 * @param {Object} argNewTitleTxt			If you go to the other page ,It would display new title eg:(Preview Payment, Preview Changes,Important Information)
 * @param {Object} argIsToolBarVisible		the toolbar show or hide eg(YES or NO)
 * @param {Object} argReloadData			initial data.(YES or NO)
 */
function switchPages(argToolBarType, argDisableToolBar, argTotalPaymentAmt, argNewTitleTxt, argIsToolBarVisible, argReloadData)
{
	var params = {
		"Text": argToolBarType,
		"PreviewBtnState": argDisableToolBar,
		"TotalPayment": argTotalPaymentAmt,
		"BtnText": argNewTitleTxt,
		"ToolbarVisible": argIsToolBarVisible,
		"ReloadFromWeb": convertStringToBoolean(argReloadData)
	};
    sendRequestToContainer(Messages.SWITCH_PAGES, params);
}

function convertStringToBoolean(argValue)
{
	if(argValue === undefined){
		return false;
	}

    switch (argValue.toLowerCase())
    {
        case "true":
        case "yes":
        case "1":
            return true;
        case "false":
        case "no":
        case "0":
        case null:
            return false;
        default:
            return Boolean(argValue);
    }
}


/**
 * close billpay.
 */
function hideToolBar()
{
	var paramObj = {"IsHideToolBar":"NO"};
    sendRequestToContainer(Messages.HIDE_TOOLBAR, paramObj);
}

/**
 * show toolbar.
 */
function showToolBar()
{
	var paramObj = {"IsShowToolBar":"YES"};
    sendRequestToContainer(Messages.HIDE_TOOLBAR, paramObj);
}

/**
 * set title name.
 * @param argTitleName
 */
function setTitle(argTitleName)
{
	var paramObj = {"TitleName":argTitleName};
    sendRequestToContainer(Messages.SET_TITLE, paramObj);
}

/**
 * exit window.
 * @param argAccount
 */
function exitBillPay(argAccount)
{
	var paramObj = {"Account":argAccount};
    sendRequestToContainer(Messages.EXIT_BILLPAY,paramObj);
}

/**
 * set total payment.
 * @param argTotalPay
 */
function setTotalPay(argTotalPay)
{
	var paramObj = {"TotalPay":argTotalPay};
    sendRequestToContainer(Messages.UPDATE_TOTAL_PAYMENT,paramObj);
}

/**
 * set default account.
 */
function loadDefaultAccount()
{
    sendRequestToContainer(Messages.GET_DEFAULT_BROKERAGE_ACCOUNT, null);
}

/**
 * Display brokerage account list.
 */
function showBrokerageAccountsList(argAccount)
{
    var payment_type = "SCHEDULE";
    
    if ($("#tab_bar_pending").hasClass("select")) 
    {
        payment_type = "PENDING";
    }
    var paramObj = {
    		
    	"PaymentType":payment_type,
    	"AccountDetails":argAccount
    };

    sendRequestToContainer(Messages.SHOW_BROKERAGE_ACCOUNT_LIST,paramObj);
}

/**
 * post the data of changed payee items of schedule payment to back end.
 * @param argSubmitInfo
 */
function postDataOfSubmitPayments(argSubmitInfo)
{
    confirmation = "schedule";
    goBackInfomations(network_error_toolbar_text,"", "","Preview Payments", "YES", "preview_payment");
    var paramObj = {"SubmitInfo":argSubmitInfo};
    sendRequestToContainer(Messages.SUBMIT_PAYMENTS, paramObj);
}

/**
 * post the data of changed payee items of pending payment to back end.
 * @param argSubmitInfo
 */
function postDataOfSubmitChanges(argSubmitInfo)
{
    confirmation = "pending";
    goBackInfomations(network_error_toolbar_text,"", "","Preview Changes", "YES", "preview_changes");
    var paramObj = {"SubmitInfo":argSubmitInfo};
    sendRequestToContainer(Messages.SUBMIT_CHANGES,paramObj);
}

function isPaymentChanged4Android()
{
    var result;
    if ($.trim($("#confirmation_info").attr("class")) == "current") 
    {
        result = "NO";
    }
    else 
    {
        if ($("#tab_bar_pending").hasClass('select')) 
        {
            result = isPendingPaymentChanged() ? "YES" : "NO";
        }
        else 
        {
            result = isSchedulePaymentChanged() ? "YES" : "NO";
        }
    }
    var paramsObj = {"Type":"IS_PAYMENT_CHANGED","Result":result};
    sendRequestToContainer(Messages.JS_RESULT,paramsObj);
}

/**
 * go back previous page when you click 'close' or 'edit' button.
 */
function gotoPage()
{
    if (page_transition_stack.length == 0)
    {
        var result;
        if (isPaymentChanged() == 'YES')
        {
            var account = null;
            var selected_account_val = $("#txt_accounts_list").val();
            if (selected_account_val !== undefined && selected_account_val.length > 0)
            {
                account = getAccountNumber(selected_account_val);
            }
            result = account;
        }
        else
        {
            result = "NO";
        }      
        var paramsObj = {"Type":"GOTO_PAGE","Result":result};
        sendRequestToContainer(Messages.JS_RESULT,paramsObj);
    }
    else
    {
    	var current_page_info = page_transition_stack[page_transition_stack.length - 1];
    	if (current_page_info[5] !== undefined && current_page_info[5] != null && current_page_info[5].length > 0)
	    {
	    	JQT.goBack('#' + current_page_info[5]);
	        if (current_page_info[4] != "YES")
	        {
	            switchPages(current_page_info[0], current_page_info[1], current_page_info[2], current_page_info[3], "NO");
	        }
	    }
	    else
	    {
	        $('#update_schedule_payment,#schedule_schedule_payment').attr("disabled", "disabled").addClass("btn-disabled");
	        $('#update_pending_payment').attr("disabled", "disabled").addClass("btn-disabled");
	        JQT.goBack("#home");
	        is_back_from_auto_pay = false;
	        switchPages(current_page_info[0], current_page_info[1], current_page_info[2], current_page_info[3], current_page_info[4]);
	        selected_pending_id = "";
	        selected_schedule_id = "";
	    }
	    page_transition_stack.pop(page_transition_stack.length - 1);
    }
}

/**
 * go to home page
 */
function gotoHomePage()
{
    JQT.goTo("#home", 'slide');
    if (is_error_pending_submit) 
    {
        is_error_pending_submit = false;
        switchPages("PREVIEW_PENDING_PAYMENT", "ENABLE", $("#pending_total_pay").val(), "Pay Bills", "YES", "NO");
    }
    else 
    {
        is_error_schedule_submit = false;
        switchPages("PREVIEW_SCHEDULING_PAYMENT", "ENABLE", $("#schedule_total_pay").val(), "Pay Bills", "YES", "NO");
    }
}

/**
 * 
 * @param argTypeName
 * @param argParameters
 */
function sendRequestToContainer(argTypeName, argParameters)
{
    var msg = 
    {
    	 "Message":{
    	 	"Command": argTypeName,
    	 	"Parameters":argParameters
    	 }
       
    };
    
    var jsonStr = JSON.stringify(msg);
    if (window.JS2Android) 
    {
        window.JS2Android.call(jsonStr);
    }

}