/**
 * Copyright 2011, FMR LLC. All Rights Reserved. Fidelity Confidential
 * Information
 * 
 * @author Nylon Gao (a488606)
 */
var ToolBarMessages = 
{
		PREVIEW_PAYMENT: 'PREVIEW_PAYMENT',
		PREVIEW_CHANGES: 'PREVIEW_CHANGES',
		CONFIRM_SUBMIT_PAYMENTS: 'CONFIRM_SUBMIT_PAYMENTS',
		CONFIRM_SUBMIT_CHANGES: 'CONFIRM_SUBMIT_CHANGES'
};

/**
 * 
 * @param argTypeName
 * @param argParameters
 */
function sendToolBarRequestToContainer(argTypeName, argParameters)
{
    var msg = 
    {
    	 "Message":{
    	 	"Command": argTypeName,
    	 	"Parameters":argParameters
    	 }
       
    };
    
    var jsonStr = JSON.stringify(msg);
    if (window.JS2Android) 
    {
        window.JS2Android.call(jsonStr);
    }

}

$(document).ready(function(){
    $("#btn_preview").bind("touchstart", function(argEvent){
    	sendToolBarRequestToContainer(ToolBarMessages.PREVIEW_PAYMENT,null);
    });		
});

function showPreviewToolbar(argType, argEnable){
	var cmd;
	if(argType == 'PreviewPayments'){
		$("#btn_preview").text("Preview Payment");
		cmd = ToolBarMessages.PREVIEW_PAYMENT;
	}else{
		$("#btn_preview").text("Preview Change");
		cmd = ToolBarMessages.PREVIEW_CHANGES;
	}
	
	if(argEnable == true || argEnable.toUpperCase() == "ENABLE")
	{
		$("#btn_preview")
            .removeClass("gray")
            .addClass("green")
            .unbind("touchstart")
            .bind("touchstart", function(argEvent){
            	sendToolBarRequestToContainer(cmd,null);
        });		
	}
	else{
		$("#btn_preview").removeClass("green")
                        .addClass("gray")
                        .unbind("touchstart");		
	}
	
	$("#footer_submit").css("display", "none");
	$("#footer").css("display", "block");
};

function showSubmitToolbar(argType){
	var cmd;
	if(argType == 'SubmitPayments'){
		$("#btn_submit").text("Submit Payments");
		cmd = ToolBarMessages.CONFIRM_SUBMIT_PAYMENTS;
	}else if(argType == 'SubmitPayment'){
        $("#btn_submit").text("Submit Payment");
		cmd = ToolBarMessages.CONFIRM_SUBMIT_PAYMENTS;
	}else if(argType == 'SubmitChanges'){
        $("#btn_submit").text("Submit Changes");
		cmd = ToolBarMessages.CONFIRM_SUBMIT_CHANGES;
    }else{
        $("#btn_submit").text("Submit Change");
		cmd = ToolBarMessages.CONFIRM_SUBMIT_CHANGES;
    }
	
	$("#btn_submit")
        .removeClass('gray font-color-999')
        .unbind("touchstart")
        .bind("touchstart", function(event){    
            $(this).removeClass('green').addClass('green-hover');
        }).unbind("touchend")
        .bind("touchend", function(event){
            $(this).removeClass('green-hover').addClass('green');
            sendToolBarRequestToContainer(cmd,null);
    });
	$("#footer").css("display", "none");
	$("#footer_submit").css("display", "block");		
};

function disableSubmitButton(){
	$("#btn_submit").unbind("touchstart")
                    .unbind("touchend")
                    .removeClass('font-color-white')
                    .addClass('gray font-color-999');
}

function disablePreviewButton(){
    $("#btn_preview").unbind("touchstart")
                    .unbind("touchend")
                    .removeClass('green')
                    .addClass('gray');
}